#pragma once

#ifndef _LMC_
#define _LMC_

#ifndef _WINDOWS_

#ifndef WINVER
#define WINVER 0x0501
#endif

#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x501
#endif

#include <windows.h>

#endif

#ifdef __cplusplus 
extern "C" {
#endif

typedef struct _DICTIONARY_ENTRY
{
	DWORD dwEntryNameSize;
	LPWSTR lpEntryName;
	DWORD dwOffset;
	DWORD dwSize;
	DWORD dwSeed;
} DICTIONARY_ENTRY, *LPDICTIONARY_ENTRY;

typedef struct _FILE_LIST_ENTRY
{
	LPWSTR lpPath;
	struct _FILE_LIST_ENTRY* lpNextEntry;
} FILE_LIST_ENTRY, *LPFILE_LIST_ENTRY, FILE_LIST, *LPFILE_LIST;

// ファイル読み込み
HANDLE LMCOpenFile(LPCWSTR lpFileName);
DWORD LMCReadDictionary(HANDLE hFile, LPDICTIONARY_ENTRY* lpDictionaryBuffer, LPDWORD lpEntriesFound);
DWORD LMCExtractToFile(HANDLE hFile, LPDICTIONARY_ENTRY lpEntry, LPCWSTR lpDestinationPath);
DWORD LMCExtractToMemory(HANDLE hFile, LPDICTIONARY_ENTRY lpEntry, LPVOID* lpDestinationBuffer);
BOOL LMCCloseFile(HANDLE hFile, LPDICTIONARY_ENTRY lpDictionaryBuffer, DWORD dwEntryCount);
LPDICTIONARY_ENTRY LMCFindFile(LPDICTIONARY_ENTRY lpDictionary, DWORD dwEntryCount, LPCWSTR lpFileName);

// ファイル作成
LPFILE_LIST LMCCreateFileList(LPCWSTR lpBasePath);
BOOL LMCAddFile(LPFILE_LIST lpFileList, LPCWSTR lpPath);
BOOL LMCWriteFile(LPCWSTR lpFileName, LPFILE_LIST lpFileList);
BOOL LMCFreeFileList(LPFILE_LIST lpFileList);

// 中途半端の暗号化
DWORD LMCCreateSeed();
DWORD LMCXORBytes(DWORD dwSeed, LPVOID lpBuffer, DWORD dwBufferLength);

// 数字変換
int LMCVLIntToInt(int value, int* lpBytesUsed);
int LMCIntToVLInt(int value, int* lpBytesUsed);

// 共通関数
LPVOID LMCCreateBuffer(DWORD dwSize);
DWORD LMCFreeBuffer(LPVOID lpBuffer);

// その他
BOOL LMCAuxWriteDWORD(HANDLE hFile, DWORD dwValue);
BOOL LMCAuxWriteBuffer(HANDLE hFile, LPVOID lpBuffer, int nBytesToWrite);
DWORD LMCAuxReadDWORD(HANDLE hFile);
LPVOID LMCAuxReadBuffer(HANDLE hFile, int nBytesToRead);
LPVOID LMCAuxReadFile(LPCWSTR lpFileName, int nBytesToRead);

#endif


#ifdef __cplusplus 
}
#endif

