#include <lmc.h>
#include <string.h>
#include <stdio.h>

int compress_file(wchar_t* conf_file, wchar_t* def_file)
{
	wchar_t base_path[MAX_PATH];
	wchar_t dest_file[MAX_PATH];
	wchar_t curr_file[MAX_PATH];
	FILE* fIn;
	FILE* fConf;
	LPFILE_LIST lpFileList;

	if (_wfopen_s(&fConf, conf_file, L"rt") == 0)
	{
		fgetws(base_path, MAX_PATH, fConf);
		fgetws(dest_file, MAX_PATH, fConf);
		fclose(fConf);
	}
	else
	{
		return -1;
	}
	if (_wfopen_s(&fIn, def_file, L"rt") != 0)
		return -1;
	dest_file[wcslen(dest_file) - 1] = 0;
	lpFileList = LMCCreateFileList(base_path);

	while(!feof(fIn))
	{
		fgetws(curr_file, MAX_PATH, fIn);
		wprintf(L"Adding %s", curr_file);
		LMCAddFile(lpFileList, curr_file);
	}
	fclose(fIn);
	if (!LMCWriteFile(dest_file, lpFileList))
	{
		wprintf(L"Error packing the file.\n");
	}
	LMCFreeFileList(lpFileList);
	return 0;
}

int uncompress_file(wchar_t* file)
{
	HANDLE hFile;
	LPDICTIONARY_ENTRY lpDictionary;
	DWORD dwEntryCount;
	DWORD i;

	hFile = LMCOpenFile(file);
	LMCReadDictionary(hFile, &lpDictionary, &dwEntryCount);
	for (i = 0; i < dwEntryCount; i++)
	{
		LMCExtractToFile(hFile, &lpDictionary[i], lpDictionary[i].lpEntryName);
	}
	LMCCloseFile(hFile, lpDictionary, dwEntryCount);
	return 0;
}

int wmain(int argc, wchar_t* argv[])
{
	if (argc == 3 && wcscmp(argv[1], L"-x") == 0)
	{
		return uncompress_file(argv[2]);
	}
	else if (argc == 4 && wcscmp(argv[1], L"-c") == 0)
	{
		return compress_file(argv[2], argv[3]);
	}
	return -1;
}